
var monitor = {}
monitor.processes = {}
monitor.processes.fetch = function(){
	var httpclient = HttpClient.instance()
	httpclient.get('/get/processes',monitor.processes.init);
	
}

monitor.processes.init = function(x){
	var r = JSON.parse(x.responseText)
	var keys = jx.utils.keys(r)	
	jx.dom.set.value('menu','')
	jx.utils.patterns.visitor(keys,function(label){
		var div = jx.dom.get.instance('DIV')
		var frame= jx.dom.get.instance('DIV')
		var i	= jx.dom.get.instance('I')
		i.className = 'fa fa-chevron-right left'
		
		div.innerHTML	= label
		frame.data	= r[label]
		frame.label	= label
		frame.appendChild(i)
		frame.appendChild(div)
		frame.className = 'menu-item'
		frame.onclick = function () {
			monitor.processes.render(this.label, this.data);
			//monitor.processes.trend.init(this.label)
		}
		jx.dom.append('menu',frame)
	})
}
monitor.processes.render = function(label,data) {

	data = jx.utils.patterns.visitor(data,function(row){
		var status = {"idle":'<i class="fa fa-ellipsis-h" title="IDLE"></i>',"running":'<i class="fa fa-check" title="RUNNING"></i>',"crash":'<i class="fa fa-times" title="CRASHED"></i>'}	
		if (!row.status.match(/class/)) {
			row.status_id = row.status
			row.status = status[row.status]		
			
		}
		return row
	})
	jx.dom.set.value('latest_processes','') ;
	jx.dom.set.value('latest_processes_label',label)
	var options = {width:'90%'}
	
	options.data = data
	options.rowClass = function (item, index,evt) {
		
		return 'small'
	}
	options.rowClick = function(args){
		var item = args.item
		var id 	= jx.dom.get.value('latest_processes_label')
		var app = item.label
		monitor.processes.trend.init(id,app)
	}
	options.autoload  = true
	options.fields = [{name:'label',type:'text',title:"Process",headercss:"small bold",css:"small"},{name:"cpu_usage",type:"number",title:"CPU", headercss:"small bold"},{name:"memory_usage",type:"text",title:"Mem. Used",type:"number",headercss:"small bold"},{name:"memory_available",type:"number",title:"Mem. Avail",headercss:"small bold"},
	{name:"status",type:"text",title:"Status",headercss:"small bold",align:"center"}
	]
	var grid = $('#latest_processes').jsGrid(options) ;


}

monitor.processes.trend = {}
monitor.processes.trend.init = function (label,app) {
	var httpclient = HttpClient.instance()
	var uri = '/trends?id='+label+'&app='+encodeURIComponent(app)
	httpclient.get(uri, function (x) {
		var logs = JSON.parse(x.responseText)
		
		// jx.dom.set.attribute(label,'logs',logs)
		monitor.processes.trend.render(logs,null,app)
	})
}
monitor.processes.trend.render = function (logs, key,label) {
	if (key == null) {
		key = 'memory_usage'
	}
	var context = $('#trends_chart')
	var conf = { type: 'line',responsive:true,maintainAspectRatio:true }
	conf.data = {}
	conf.options = { legend: { position: 'bottom' } }
	conf.options.scales = {}
	conf.options.scales.yAxes = [ {ticks:{min:0,beginAtZero:true},gridLines: {display:false}}]
	conf.options.scales.xAxes = [
		{
			
			type: 'time',
			gridLines: {display:false},
			unitStepSize:25,
			time: {
				format:'DD-MMM HH:mm'
			}
			
		}
		
	]
	conf.data.datasets = [	]
	var x_axis = []
	var _x = {}
	var _y = {}
	var values = jx.utils.patterns.visitor(logs,function(item){
		x = new Date(item.year,item.month-1,item.day,item.hour,item.minute)
		y = item[key]
		if (_x[x] == null ||(_x[x] == null && _y[y] == null)) {
			_x[x] = 1
			_y[y] = 1
			x_axis.push(x)	
			console.log([x,y])
			return {x:x,y:y}
			
		} else {
			return null
		}
		
	})
	
	var serie = {label:label,data:values}
	i = parseInt(Math.random() * (COLORS.length - 1))
	serie.backgroundColor = 'transparent'
	serie.borderColor = COLORS[10]
	serie.borderWidth = 1
	serie.type = 'line'
	conf.data.datasets.push(serie)
	
	x_axis = jx.utils.unique(x_axis)
	
	conf.data.labels = x_axis
	// console.log(conf)
	var chart = new Chart(context,conf)

}